# gulp-jsoncombine
[![NPM version][npm-image]][npm-url] [![Build Status][travis-image]][travis-url]  [![Coverage Status][coveralls-image]][coveralls-url] [![Dependency Status][depstat-image]][depstat-url]

> jsoncombine plugin for [gulp](https://github.com/wearefractal/gulp)

## Usage

First, install `gulp-jsoncombine` as a dependency:

```shell
npm install --save-dev gulp-jsoncombine
```

Then, add it to your `gulpfile.js`:

** This plugin will collect all the json files provided to it, parse them, put them in a dictionary where the keys of that dictionary are the filenames (sans the '.json' suffix) and pass that to a processor function. That function decides how that output should look in the resulting file. **

```javascript
var jsoncombine = require("gulp-jsoncombine");

gulp.src("./src/*.json")
	.pipe(jsoncombine("result.js",function(data, meta){...}))
	.pipe(gulp.dest("./dist"));
```

## API

### jsoncombine(fileName, processor)

#### fileName
Type: `String`  

The output filename

#### processor
Type: `Function`  

The processor function will be called with two dictionaries holding the same set of keys. The keys are the filename sans the `.json` suffix of a file in the gulp stream.

The first dictionary maps the filename to the string contents of the file. The second dictionary maps to a meta object containing the following keys:

* `cwd` The working directory
* `base` The base path
* `path` The full path to the file

The function should return a new `Buffer` that would be written to the output file.

## License

[MIT License](http://en.wikipedia.org/wiki/MIT_License)

[npm-url]: https://npmjs.org/package/gulp-jsoncombine
[npm-image]: https://badge.fury.io/js/gulp-jsoncombine.png

[travis-url]: http://travis-ci.org/reflog/gulp-jsoncombine
[travis-image]: https://secure.travis-ci.org/reflog/gulp-jsoncombine.png?branch=master

[coveralls-url]: https://coveralls.io/r/reflog/gulp-jsoncombine
[coveralls-image]: https://coveralls.io/repos/reflog/gulp-jsoncombine/badge.png

[depstat-url]: https://david-dm.org/reflog/gulp-jsoncombine
[depstat-image]: https://david-dm.org/reflog/gulp-jsoncombine.png
